# WebSocketIntegration

The integration for an API route.

Extends: Construct › Resource › WebSocketIntegration
Implements: IResource, IIntegration, IWebSocketIntegration, IEnvironmentAware, IIntegrationRef, IConstruct, IDependable

- CloudFormation: [`AWS::ApiGatewayV2::Integration`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-apigatewayv2-integration.html)
- L1 type: [`CfnIntegration`](/cdk/api/v2/docs/aws-cdk-lib.aws_apigatewayv2.CfnIntegration.html)
- Source: [`aws-apigatewayv2/lib/websocket/integration.ts`](https://github.com/aws/aws-cdk/blob/v2.275.0/packages/aws-cdk-lib/aws-apigatewayv2/lib/websocket/integration.ts#L173)
- Type last changed: v2.235.0 · 15 Jan 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import * as cdk from 'aws-cdk-lib';
import { aws_apigatewayv2 as apigatewayv2 } from 'aws-cdk-lib';
import { aws_iam as iam } from 'aws-cdk-lib';

declare const role: iam.Role;
declare const webSocketApiRef: apigatewayv2.IWebSocketApiRef;
const webSocketIntegration = new apigatewayv2.WebSocketIntegration(this, 'MyWebSocketIntegration', {
  integrationType: apigatewayv2.WebSocketIntegrationType.AWS_PROXY,
  integrationUri: 'integrationUri',
  webSocketApi: webSocketApiRef,

  // the properties below are optional
  contentHandling: apigatewayv2.ContentHandling.CONVERT_TO_BINARY,
  credentialsRole: role,
  integrationMethod: 'integrationMethod',
  passthroughBehavior: apigatewayv2.PassthroughBehavior.WHEN_NO_MATCH,
  requestParameters: {
    requestParametersKey: 'requestParameters',
  },
  requestTemplates: {
    requestTemplatesKey: 'requestTemplates',
  },
  templateSelectionExpression: 'templateSelectionExpression',
  timeout: cdk.Duration.minutes(30),
});
```

## Initializer

```ts
new WebSocketIntegration(scope: Construct, id: string, props: WebSocketIntegrationProps)
```

## Construct Props

- `contentHandling`: [ContentHandling](/cdk/api/v2/docs/aws-cdk-lib.aws_apigatewayv2.ContentHandling.html) — Specifies how to handle response payload content type conversions.

  **Default:** The response payload will be passed through from the integration response to the route response or method response without modification.

- `credentialsRole`: [IRole](/cdk/api/v2/docs/aws-cdk-lib.aws_iam.IRole.html) — Specifies the IAM role required for the integration.

  **Default:** No IAM role required.

- `integrationMethod`: string — Specifies the integration's HTTP method type.

  **Default:** No HTTP method required.

- `integrationType`: [WebSocketIntegrationType](/cdk/api/v2/docs/aws-cdk-lib.aws_apigatewayv2.WebSocketIntegrationType.html) (required) — Integration type.

- `integrationUri`: string (required) — Integration URI.

- `passthroughBehavior`: [PassthroughBehavior](/cdk/api/v2/docs/aws-cdk-lib.aws_apigatewayv2.PassthroughBehavior.html) — Specifies the pass-through behavior for incoming requests based on the Content-Type header in the request, and the available mapping templates specified as the requestTemplates property on the Integration resource.

  **Default:** No passthrough behavior required.

  There are three valid values: WHEN_NO_MATCH, WHEN_NO_TEMPLATES, and
  NEVER.

- `requestParameters`: { [key: string]: string } — The request parameters that API Gateway sends with the backend request.

  **Default:** No request parameters required.

  Specify request parameters as key-value pairs (string-to-string
  mappings), with a destination as the key and a source as the value.

- `requestTemplates`: { [key: string]: string } — A map of Apache Velocity templates that are applied on the request payload.

  **Default:** No request templates required.

  ```
    { "application/json": "{ \"statusCode\": 200 }" }
  ```

- `templateSelectionExpression`: string — The template selection expression for the integration.

  **Default:** No template selection expression required.

- `timeout`: [Duration](/cdk/api/v2/docs/aws-cdk-lib.Duration.html) = Duration.seconds(29) — The maximum amount of time an integration will run before it returns without a response.

  Must be between 50 milliseconds and 29 seconds.

- `webSocketApi`: [IWebSocketApiRef](/cdk/api/v2/docs/aws-cdk-lib.aws_apigatewayv2.IWebSocketApiRef.html) (required) — The WebSocket API to which this integration should be bound.

## Properties

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html) — The environment this resource belongs to.

  For resources that are created and managed in a Stack (those created by
  creating new class instances like `new Role()`, `new Bucket()`, etc.), this
  is always the same as the environment of the stack they belong to.

  For referenced resources (those obtained from referencing methods like
  `Role.fromRoleArn()`, `Bucket.fromBucketName()`, etc.), they might be
  different than the stack they were imported into.

- `integrationId`: string — Id of the integration.

- `integrationRef`: [IntegrationReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_apigatewayv2.IntegrationReference.html) — A reference to a Integration resource.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `PROPERTY_INJECTION_ID`: string (static) — Uniquely identifies this class.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this resource is defined.

- `webSocketApi`: [IWebSocketApi](/cdk/api/v2/docs/aws-cdk-lib.aws_apigatewayv2.IWebSocketApi.html) — The WebSocket API associated with this integration.

## Methods

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Override the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  mechanism instead of the global default determined by the
  `@aws-cdk/core:defaultCrossStackReferences` context key. This is useful for
  selectively weakening specific references to avoid the "deadly embrace" problem
  without changing the app-wide default.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy: RemovalPolicy): void` — Apply the given removal policy to this resource.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`).

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `isOwnedResource(construct: IConstruct): boolean` (static) — Returns true if the construct was created by CDK, and false otherwise.

- `isResource(construct: IConstruct): boolean` (static) — Check whether the given construct is a Resource.

- `toString(): string` — Returns a string representation of this construct.

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
